local mods, actorCmds

return Def.ActorFrame {
	InitCommand = function(self)
	end,

	OnCommand = function(self)
		local screen = SCREENMAN:GetTopScreen()

		local null = self:GetChild('NullActorFrame')

		local p1 = screen:GetChild('PlayerP1')
		local p2 = screen:GetChild('PlayerP2') or null

		if not p1 then
			for i,v in pairs(screen:GetChild('')) do
				if tostring(v):find('Player') then
					p1 = v
					break
				end
			end
		end

		local players = {p1, p2}

		local p1state = GAMESTATE:GetPlayerState(PLAYER_1)
		local p2state = GAMESTATE:GetPlayerState(PLAYER_2)

		mods = {
			{0, '2.69x,*99 dark,*99 blind'},
			{12.5, '*99 no dark'},
			{112, '*99 -200% tiny'},
			{144, '*99 no tipsy'}
		}

durk={{4,4.25},{6,6.25},{8,8.25},{10,10.25}}

for i,v in pairs(durk) do
    for beat=v[1],v[2] do
        table.insert(mods, {beat, '*99 no dark'})
		table.insert(mods, {beat + 0.25, '*3 dark'})
    end
end

koolflashhhh={{32.1,32.251},{48.1,48.251},{64.1,64.251},{80.1,80.251},{96.1,96.251},{112.1,112.251},{128.1,128.251}}

for i,v in pairs(koolflashhhh) do
    for beat=v[1],v[2] do
        table.insert(mods, {beat + 0.1, '*99 55% stealth'})
		table.insert(mods, {beat + 0.251, '*3 no stealth'})
    end
end
		
for beat=16,143,1 do
	table.insert(mods, {beat, '*50 500% tipsy'})
	table.insert(mods, {beat + 0.25, '*50 -500% tipsy'})
	table.insert(mods, {beat + 0.5, '*50 500% tipsy'})
	table.insert(mods, {beat + 0.75, '*50 -500% tipsy'})
end


		local fuckBounce = function()
			p1:bounce():effectmagnitude(0, -200, 0):effectclock('beat'):effectperiod(1)
			p2:bounce():effectmagnitude(0, -200, 0):effectclock('beat'):effectperiod(1)
		end

		local stopEffect = function()
			p1:stopeffect()
			p2:stopeffect()
		end

		local fuckBob = function()
			screen:bob():effectmagnitude(100, 0, 100):effectclock('beat'):effectperiod(1)
		end
		
		local fuckVibb = function()
			screen:vibrate():effectmagnitude(50, 0, 50)
		end

		local kbye = function()
			screen:stopeffect():smooth(2):zoom(0):rotationz(45)
		end

		local rot1 = function()
			for i=1, #players do
				players[i]
					:smooth(0.1)
					:rotationz(45)
			end
		end

		local rot2 = function()
			for i=1, #players do
				players[i]
					:smooth(0.1)
					:rotationz(-45)
			end
		end
		
		local rotNo = function()
			for i=1, #players do
				players[i]
					:rotationz(0)
			end
		end
		
		local center = function()
			for i=1, #players do
				players[i]
					:x(SCREEN_CENTER_X)
			end
		end

		actorCmds = {
			{4, rot1},
			{6, rot2},
			{8, rot1},
			{10, rot2},
			{10, center},
			{12, rotNo},
			{16, fuckBounce},
			{80, fuckBob},
			{112, fuckVibb},
			{144, stopEffect},
			{144, kbye}
		}

		for i=#actorCmds, 1, -1 do
			if GAMESTATE:GetSongBeat() > actorCmds[i][1] then
				table.remove(actorCmds, i)
			end
		end

		p1:stopeffect()
		p2:stopeffect()

		local firstRun = true
		self:SetUpdateFunction(function(self, delta)
			local currentBeat = GAMESTATE:GetSongBeat()

			for i=1, #mods do
				local mod = mods[i]
				if not mod.done and currentBeat >= mod[1] then
					local modstr = table.concat({ unpack(mod, 2) }, ',')
					p1state:SetPlayerOptions('ModsLevel_Song', p1state:GetPlayerOptionsString('ModsLevel_Song')..','..modstr)
					p2state:SetPlayerOptions('ModsLevel_Song', p2state:GetPlayerOptionsString('ModsLevel_Song')..','..modstr)
					mod.done = true

					if not firstRun then
						break
					end
				end
			end

			for i=1, #actorCmds do
				local command = actorCmds[i]
				if not command.done and currentBeat > command[1] then
					command[2]()
					command.done = true
				end
			end
			
			for i=1,2 do
				SCREENMAN:GetTopScreen():GetChild('LifeP'..i):visible(false);
                SCREENMAN:GetTopScreen():GetChild('ScoreP'..i):visible(false);
				SCREENMAN:GetTopScreen():GetChild('Overlay'):visible(false);
				SCREENMAN:GetTopScreen():GetChild('Underlay'):visible(false);
				SCREENMAN:GetTopScreen():GetChild('BPMDisplay'):visible(false);
				SCREENMAN:GetTopScreen():GetChild('StageDisplay'):visible(false);
				SCREENMAN:GetTopScreen():GetChild('SongTitle'):visible(false);
				SCREENMAN:GetTopScreen():GetChild("SongMeterDisplay" .. PlayerNumberToString(i-1)):visible(false);
				SCREENMAN:GetTopScreen():GetChild("StepsDisplay" .. PlayerNumberToString(i-1)):visible(false);
			end

			if firstRun then
				p1:finishtweening()
				p2:finishtweening()
			end
			firstRun = false
		end)
	end,
	
	Def.Sprite{
    InitCommand= cmd(hibernate,27.047;x,SCREEN_CENTER_X-100;y,SCREEN_CENTER_Y;zoom,999;rainbow,1;blend,'invertdest'),
    OnCommand= cmd(sleep,999;diffusealpha,0),
    Texture= "white.png",
  },
	
	Def.Sprite{
    InitCommand= cmd(hibernate,27.047;x,SCREEN_CENTER_X-100;y,SCREEN_CENTER_Y;bob,1;effectmagnitude,500, 0, 500;effectclock,'beat';effectperiod,1),
    OnCommand= cmd(sleep,999;diffusealpha,0),
    Texture= "owam.png",
  },
  
	Def.Sprite{
    InitCommand= cmd(hibernate,31.545;x,SCREEN_CENTER_X+100;y,SCREEN_CENTER_Y;bob,1;effectmagnitude,-500, 0, -500;effectclock,'beat';effectperiod,1),
    OnCommand= cmd(sleep,999;diffusealpha,0),
    Texture= "owam mirror.png",
  },

	Def.Quad{ OnCommand = function(self) self:sleep(1000) end },
	Def.ActorFrame{ Name='NullActorFrame' },
}
